// Load dts shapes and merge animations
datablock TSShapeConstructor(PoisonMiteDts)
{
	baseShape  = "./poison_mite2.dts";
	sequence0  = "./psmt_root.dsq root";

	sequence1  = "./psmt_run.dsq run";
	sequence2  = "./psmt_run.dsq walk";
	sequence3  = "./psmt_back.dsq back";
	sequence4  = "./psmt_side.dsq side";

	sequence5  = "./psmt_root.dsq crouch";
	sequence6  = "./psmt_run.dsq crouchRun";
	sequence7  = "./psmt_back.dsq crouchBack";
	sequence8  = "./psmt_side.dsq crouchSide";

	sequence9  = "./psmt_root.dsq look";
	sequence10 = "./psmt_root.dsq headside";
	sequence11 = "./psmt_root.dsq headUp";

	sequence12 = "./psmt_jump.dsq jump";
	sequence13 = "./psmt_jump.dsq standjump";
	sequence14 = "./psmt_fall.dsq fall";
	sequence15 = "./psmt_root.dsq land";

	sequence16 = "./psmt_attack.dsq armAttack";
	sequence17 = "./psmt_root.dsq armReadyLeft";
	sequence18 = "./psmt_root.dsq armReadyRight";
	sequence19 = "./psmt_root.dsq armReadyBoth";
	sequence20 = "./psmt_root.dsq spearready";  
	sequence21 = "./psmt_attack.dsq spearThrow";

	sequence22 = "./psmt_attack.dsq talk";  

	sequence23 = "./psmt_death.dsq death1"; 
	
	sequence24 = "./psmt_root.dsq shiftUp";
	sequence25 = "./psmt_root.dsq shiftDown";
	sequence26 = "./psmt_root.dsq shiftAway";
	sequence27 = "./psmt_root.dsq shiftTo";
	sequence28 = "./psmt_root.dsq shiftLeft";
	sequence29 = "./psmt_root.dsq shiftRight";
	sequence30 = "./psmt_root.dsq rotCW";
	sequence31 = "./psmt_root.dsq rotCCW";

	sequence32 = "./psmt_root.dsq undo";
	sequence33 = "./psmt_attack.dsq plant";

	sequence34 = "./psmt_death.dsq sit";

	sequence35 = "./psmt_root.dsq wrench";

   sequence36 = "./psmt_attack.dsq activate";
   sequence37 = "./psmt_attack.dsq activate2";

   sequence38 = "./psmt_root.dsq leftrecoil";
};    

//datablock AudioProfile(MitePainSound)
//{
//   fileName = "./psmt_pain.wav";
//   description = AudioClose3d;
//   preload = true;
//};
//datablock AudioProfile(MiteDeathSound)
//{
//   fileName = "./psmt_death.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock fxDTSBrickData (BrickPoisonMiteBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes - BugMods";
	uiName = "Poison Mite Hole";
	iconName = "Add-Ons/Bot_BugMod4_HiveInvasion/icon_poisonmite";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "PoisonMiteArmor";
};

datablock PlayerData(PoisonMiteArmor : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./poison_mite2.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 50;			//65
	runforce = 70 * 90;
	maxForwardSpeed = 10;	//10.5
	maxBackwardSpeed = 9;
	maxSideSpeed = 6;		//5
//	attackpower = 20;
	jumpsound = "";
	
    boundingBox				= vectorScale("1.1 1.1 0.5", 4); //"2.5 2.5 2.4" 
    crouchBoundingBox		= vectorScale("1.1 1.1 0.5", 4); //"2.5 2.5 2.4";
	proneBoundingBox		= vectorScale("1.1 1.1 0.5", 4); //"2.5 2.5 2.4";

	maxForwardCrouchSpeed = 4;
	maxBackwardCrouchSpeed = 3;		//2
	maxSideCrouchSpeed = 3;			//2

	mass = 100;

    maxStepHeight = 0.4; 

	jumpForce = 10.5 * 100; //10 * 100;
	jumpDelay = 0.2;	

	minImpactSpeed = 25;	//20
	speedDamageScale = 3;	//4.3

	BrickDestroyMaxVolume = 150;
	BrickMaxJumpHeight = 10;
	uiName = "B4 Poison Mite";
	rideable = false;		//true
	canRide = false;
	BrickKillRadius = 2;
//	FollowAnim = "ArmReadyBoth";
	numMountPoints = 0;
//	ZombieTeam = "Mites";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 70;
//	SearchRadius = 50;
//	SpecialAttack = 0;
//	zDeathSound = "MiteDeathSound";
//	ignorePipeBombs = 0;
	paintable = true;

	isSmallEnemy = 1;

    useCustomPainEffects = true;
	PainHighImage = "PainMidImage";
	PainMidImage  = "PainLowImage";
	PainLowImage  = "PainLowImage";
	PainSound           = MitePainSound;
	DeathSound          = MiteDeathSound;

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Mite; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "PoisonMite";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 12;//Melee Damage
	hShoot = 1;
	  hWep = "PoisonMiteBiteItem";
	  hShootTimes = 5;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 16;//The range in which the bot will shoot the player	//64
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 1;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};
//function PoisonMiteArmor::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function PoisonMiteArmor::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function PoisonMiteArmor::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function PoisonMiteArmor::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function PoisonMiteArmor::onAdd(%this,%obj)
//{
//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//}
function PoisonMiteArmor::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

//	%color = getRandom(0,1);
//	if(%color == 0)
		%obj.chestColor = "0.746 0.677 0.652 1";
//	if(%color == 1)
//		%obj.chestColor = "0.1 0.1 0.1 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Poison Mite";
//	schedule(15,0,recolorbug,%obj);
	//%obj.mountimage(gunimage,0);
}
