// Load dts shapes and merge animations
datablock TSShapeConstructor(SpineMiteArmorDts)
{
	baseShape  = "./spine_mite.dts";
	sequence0  = "./spnmt_root.dsq root";

	sequence1  = "./spnmt_run.dsq run";
	sequence2  = "./spnmt_run.dsq walk";
	sequence3  = "./spnmt_back.dsq back";
	sequence4  = "./spnmt_side.dsq side";

	sequence5  = "./spnmt_crouch.dsq crouch";
	sequence6  = "./spnmt_crouchMove.dsq crouchRun";
	sequence7  = "./spnmt_crouchMove.dsq crouchBack";
	sequence8  = "./spnmt_crouchMove.dsq crouchSide";

	sequence9  = "./spnmt_root.dsq look";
	sequence10 = "./spnmt_root.dsq headside";
	sequence11 = "./spnmt_root.dsq headUp";

	sequence12 = "./spnmt_jump.dsq jump";
	sequence13 = "./spnmt_jump.dsq standjump";
	sequence14 = "./spnmt_fall.dsq fall";
	sequence15 = "./spnmt_root.dsq land";

	sequence16 = "./spnmt_attack.dsq armAttack";
	sequence17 = "./spnmt_root.dsq armReadyLeft";
	sequence18 = "./spnmt_root.dsq armReadyRight";
	sequence19 = "./spnmt_root.dsq armReadyBoth";
	sequence20 = "./spnmt_root.dsq spearready";  
	sequence21 = "./spnmt_spines_fire.dsq spearThrow";

	sequence22 = "./spnmt_attack.dsq talk";  

	sequence23 = "./spnmt_death.dsq death1"; 
	
	sequence24 = "./spnmt_attack.dsq shiftUp";
	sequence25 = "./spnmt_root.dsq shiftDown";
	sequence26 = "./spnmt_spit.dsq shiftAway";
	sequence27 = "./spnmt_root.dsq shiftTo";
	sequence28 = "./spnmt_root.dsq shiftLeft";
	sequence29 = "./spnmt_root.dsq shiftRight";
	sequence30 = "./spnmt_root.dsq rotCW";
	sequence31 = "./spnmt_root.dsq rotCCW";

	sequence32 = "./spnmt_attack.dsq undo";
	sequence33 = "./spnmt_spit.dsq plant";

	sequence34 = "./spnmt_death.dsq sit";

	sequence35 = "./spnmt_attack.dsq wrench";

   sequence36 = "./spnmt_attack.dsq activate";
   sequence37 = "./spnmt_attack.dsq activate2";

   sequence38 = "./spnmt_attack.dsq leftrecoil";
};    

//datablock AudioProfile(MitePainSound)
//{
//   fileName = "./mite_pain.wav";
//   description = AudioClose3d;
//   preload = true;
//};
//datablock AudioProfile(MiteDeathSound)
//{
//   fileName = "./mite_death.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock fxDTSBrickData (BrickSpineMiteBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes - BugMods";
	uiName = "Spine Mite Hole";
	iconName = "Add-Ons/Bot_BugMod4_HiveInvasion/icon_spinemite";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "SpineMiteArmor";
};

datablock PlayerData(SpineMiteArmor : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./spine_mite.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 130;	//160
	runforce = 70 * 150;
	maxForwardSpeed = 5.5;	//5
	maxBackwardSpeed = 5;	//5
	maxSideSpeed = 4;		//5
//	attackpower = 30;
	jumpsound = "";
	
    boundingBox				= vectorScale("1.65 1.65 0.65", 4); //"2.5 2.5 2.4" 
    crouchBoundingBox		= vectorScale("1.65 1.65 0.25", 4); //"2.5 2.5 2.4";
	proneBoundingBox		= vectorScale("1.65 1.65 0.65", 4); //"2.5 2.5 2.4";

	maxForwardCrouchSpeed = 1;
	maxBackwardCrouchSpeed = 1;
	maxSideCrouchSpeed = 1;

	mass = 150;

	jumpForce = 10.3 * 150; //9.3 * 90;
	jumpDelay = 0.1;	

	minImpactSpeed = 25;	//28
	speedDamageScale = 3;	//4.3

	maxStepHeight = 0.5;

	BrickDestroyMaxVolume = 150;
	BrickMaxJumpHeight = 10;
	uiName = "B4 Spine Mite";
	rideable = false;		//true
	canRide = false;

	rechargeRate = 0.55; 	//0.53
	maxEnergy = 100;
	showEnergyBar = true;

	BrickKillRadius = 2;
//	FollowAnim = "ArmReadyBoth";
	numMountPoints = 0;
//	ZombieTeam = "Mites";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 100;
//	SearchRadius = 50;
//	SpecialAttack = 0;
//	zDeathSound = "MiteDeathSound";
//	ignorePipeBombs = 0;
	paintable = true;

	isSmallEnemy = 1;

    useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = MitePainSound;
	DeathSound          = MiteDeathSound;
	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Mite; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "SpineMite";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 16;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 48;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 12;//Melee Damage
	hShoot = 1;
	  hWep = "MiteSpineShotItem";
	  hShootTimes = 3;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 64;//The range in which the bot will shoot the player	//64
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 5;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 1;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};

//function SpineMiteArmor::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function SpineMiteArmor::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function SpineMiteArmor::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function SpineMiteArmor::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function SpineMiteArmor::onAdd(%this,%obj)
//{
//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//}
function SpineMiteArmor::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

//	%color = getRandom(0,1);
//	if(%color == 0)
		%obj.chestColor = "0.577 0.471 0.472 1";
//	if(%color == 1)
//		%obj.chestColor = "0.1 0.1 0.1 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Spine Mite";
//	schedule(15,0,recolorbug,%obj);
	//%obj.mountimage(gunimage,0);
}
