// Load dts shapes and merge animations
datablock TSShapeConstructor(BluewaspArmorDts)
{
	baseShape  = "./blue_wasp2.dts";
	sequence0  = "./blwsp_root.dsq root";

	sequence1  = "./blwsp_run.dsq run";
	sequence2  = "./blwsp_run.dsq walk";
	sequence3  = "./blwsp_back.dsq back";
	sequence4  = "./blwsp_side.dsq side";

	sequence5  = "./blwsp_crouch.dsq crouch";
	sequence6  = "./blwsp_crouchMove.dsq crouchRun";
	sequence7  = "./blwsp_crouchBack.dsq crouchBack";
	sequence8  = "./blwsp_crouchSide.dsq crouchSide";

	sequence9  = "./blwsp_root.dsq look";
	sequence10 = "./blwsp_root.dsq headside";
	sequence11 = "./blwsp_root.dsq headUp";

	sequence12 = "./blwsp_jump.dsq jump";
	sequence13 = "./blwsp_jump.dsq standjump";
	sequence14 = "./blwsp_fly_loop.dsq fall";
	sequence15 = "./blwsp_root.dsq land";

	sequence16 = "./blwsp_root.dsq armAttack";
	sequence17 = "./blwsp_root.dsq armReadyLeft";
	sequence18 = "./blwsp_root.dsq armReadyRight";
	sequence19 = "./blwsp_root.dsq armReadyBoth";
	sequence20 = "./blwsp_root.dsq spearready";  
	sequence21 = "./blwsp_bite.dsq spearThrow";

	sequence22 = "./blwsp_bite.dsq talk";  

	sequence23 = "./blwsp_death.dsq death1"; 
	
	sequence24 = "./blwsp_root.dsq shiftUp";
	sequence25 = "./blwsp_root.dsq shiftDown";
	sequence26 = "./blwsp_root.dsq shiftAway";
	sequence27 = "./blwsp_root.dsq shiftTo";
	sequence28 = "./blwsp_root.dsq shiftLeft";
	sequence29 = "./blwsp_root.dsq shiftRight";
	sequence30 = "./blwsp_root.dsq rotCW";
	sequence31 = "./blwsp_root.dsq rotCCW";

	sequence32 = "./blwsp_root.dsq undo";
	sequence33 = "./blwsp_bite.dsq plant";

	sequence34 = "./blwsp_crouch.dsq sit";

	sequence35 = "./blwsp_bite.dsq wrench";

   sequence36 = "./blwsp_bite.dsq activate";
   sequence37 = "./blwsp_bite.dsq activate2";

   sequence38 = "./blwsp_root.dsq leftrecoil";
   
   sequence39 = "./blwsp_sting_ready.dsq stingReady";	//stingReady so it will work with scorpion sting weapons
   sequence40 = "./blwsp_fly.dsq Fly";
   sequence41 = "./blwsp_sting.dsq sting";
};

datablock fxDTSBrickData (BrickBluewaspBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes - BugMods";
	uiName = "Blue Wasp Hole";
	iconName = "Add-Ons/Bot_BugMod4_HiveInvasion/icon_bluewasp";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "BluewaspArmor";
};

datablock PlayerData(BluewaspArmor : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./blue_wasp2.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	runforce = 100 * 90;
	maxForwardSpeed = 13;	//11
	maxBackwardSpeed = 12;
	maxSideSpeed = 11;
	maxForwardCrouchSpeed = 7;		//10
	maxBackwardCrouchSpeed = 6;		//9
	maxSideCrouchSpeed = 6;			//7
	jumpForce = 10 * 90; //8.3 * 90;
    jumpDelay = 0;
//	attackpower = 25;
	//jumpsound = "ArmorJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
//	BrickDestroyMaxVolume = 250;
//	BrickMaxJumpHeight = 3;
	uiName = "B4 Blue Wasp";
	rideable = true;
	canRide = false;
//	BrickKillRadius = 2;
	skinColor = "1.0 0.1 0.0 1";
//	FollowAnim = "root";
//	randomwalk = 1;
//	aimatplayer = 1;
//	SpecialAttack = 0;
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 50;
//	SearchRadius = 50;
//	ZombieTeam = "Dragonflies";
	maxDamage = 80;	//90
	jumpsound = "";
	paintable = false;

	boundingBox				= vectorScale("1.82 1.82 1.4", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("1.82 1.82 0.9", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("1.82 1.82 0.9", 4); //"2.5 2.5 2.4";
	mass = 90;
	drag = 0.28;	//0.05
    minImpactSpeed = 160;
	speedDamageScale = 0.5;    
	numMountPoints = 0;
	airControl		= 0.75;	//0.9
//	maxStepHeight = 0.5;

	isSmallEnemy = 1;

	maxEnergy = 150;
	rechargeRate = 1.5;
	showEnergyBar = true;

	useCustomPainEffects = true;
	PainHighImage		= "PainHighImage";
	PainMidImage		= "PainMidImage";
	PainLowImage		= "PainLowImage";
	PainSound			= "";
	DeathSound			= "";


	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Wasp; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "BlueWasp";//cannot contain spaces
	hTickRate = 2500;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 128;//in brick units	//64
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 17;//Melee Damage
	hShoot = 1;
	  hWep = "BlueWaspBiteItem";
	  hShootTimes = 6;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 16;//The range in which the bot will shoot the player	//64
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 5;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 1;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};
function BluewaspArmor::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Bluewasp";

//	schedule(15,0,recolorbug,%obj);

	//schedule(10,0,nazify,%obj);
	//schedule(15,0,nazify,%obj);
	//schedule(20,0,ghostifybot,%obj);
	//%obj.playthread(2,armreadyright);
	//%obj.setarmthread(crouch);
//	%obj.mountimage(JSpiderBiteImage,0);
}
function BluewaspArmor::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 10");	//10
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
