//Weapon_BQueen_Spit.cs

//audio
//datablock AudioProfile(BQueenSpitShot1Sound)
//{
//   filename    = "./syringe.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock AudioProfile(BQueenHealSound)
{
	filename = "./Heal_sfx.wav";
	description = AudioClosest3d;
	preload = true;
};

//Trail effects
datablock ParticleData(BQueenSpitTrailParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.3;
	inheritedVelFactor   = 0.01;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.4 1 0.4 0.5";
	colors[1]     = "0.6 1 0 0.1";
	colors[2]     = "0 1 0 0.02";
//	colors[3]     = "1 1 1 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.15;
	sizes[2]      = 0.01;
//	sizes[3]      = 0.1;
   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1;
//   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BQueenSpitTrailEmitter)
{
   ejectionPeriodMS = 6;
   periodVarianceMS = 3;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.07;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = "BQueenSpitTrailParticle";
};

//Heal Emote effects
datablock ParticleData(BQueenHealParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 5.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed			= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.9 0.5 0.0";
	colors[1]     = "0.55 0.9 0.1 0.2";
	colors[2]     = "0.3 0.9 0.0 0.0";
//	colors[3]     = "1 1 1 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.25;
	sizes[2]      = 0.05;
//	sizes[3]      = 0.1;
   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1;
//   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BQueenHealEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = -3.5;
   velocityVariance = 0;
   ejectionOffset   = 2.5;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = false;
   particles = "BQueenHealParticle";

	uiName = "Bug Acid Heal";
};

//Explosion effects
datablock ParticleData(BQueenSpitExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 1 0.1 0.4";
	colors[1]     = "0.1 1 0 0.1";
//	colors[2]     = "1 1 1 0.02";
//	colors[3]     = "1 1 1 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.01;
//	sizes[2]      = 0.25;
//	sizes[3]      = 0.1;
   times[0] = 0.0;
   times[1] = 1;
//   times[2] = 0.4;
//   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BQueenSpitExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1.5;
   velocityVariance = 1;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = "BQueenSpitExplosionParticle";
};

//Heal Explosion
datablock ExplosionData(BQueenHealExplosion)
{
   lifeTimeMS = 400;
   emitter[0] = BQueenHealEmitter;
   soundProfile = BQueenHealSound;
};

datablock ProjectileData(BQueenHealProjectile)
{
   explosion           = BQueenHealExplosion;

   armingDelay         = 0;
   lifetime            = 10;
   explodeOnDeath		= true;
};

//Impact Explosion
datablock ExplosionData(BQueenSpitExplosion)
{
//   explosionShape = "";
   explosionShape = "base/data/shapes/empty.dts";
//	soundProfile = rocketExplodeSound;

   lifeTimeMS = 350;

   particleEmitter = BQueenSpitExplosionEmitter;
   particleDensity = 20;
   particleRadius = 0.02;

//   emitter[0] = rocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1.0 1.5 1.0";
   camShakeAmp = "0.2 0.25 0.2";
   camShakeDuration = 4;
   camShakeRadius = 0.01;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0.03;
   lightStartColor = "0.1 0.5 0 1";
   lightEndColor = "0 0 0 1";

//   damageRadius = 3;
//   radiusDamage = 100;

//   impulseRadius = 6;
//   impulseForce = 4000;
};

datablock ProjectileData(BQueenSpitProjectile)
{
//   projectileShapeName = "";
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 10;	//20
//   directDamageType    = $DamageType::Generic;
//   radiusDamageType    = $DamageType::Generic;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = BQueenSpitExplosion;
   particleEmitter     = BQueenSpitTrailEmitter;

   muzzleVelocity      = 16;	//14.5
   velInheritFactor    = 0.5;		//0

   armingDelay         = 00;
   lifetime            = 600;
   fadeDelay           = 20;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.3;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 0.1 0";

	uiName = "Bug Healing Acid";
};

//////////
// item //
//////////
datablock ItemData(BQueenSpitItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
//	shapeFile = "";
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Bug Healing Acid";
	iconName = "./icon_acidHeal";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = BQueenSpitImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BQueenSpitImage)
{
   // Basic Item properties
//	shapeFile = "";
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = BQueenSpitProjectile;
   projectileType = Projectile;

//	casing = BQueenSpitShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   colorShiftColor = BQueenSpitItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";
//	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
//	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.15;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

//	stateName[3] = "Smoke";
//	stateTimeoutValue[3]            = 0.15;
//	stateTransitionOnTimeout[3]     = "Reload";

	stateName[3]			= "Reload";
//	stateSequence[3]                = "Reload";
	stateTimeoutValue[3]            = 0.5; //0.15
	stateTransitionOnTimeout[3]     = "Ready";
//	stateSequence[3]	= "Ready";

	minShotTime = 600; //minimum time allowed between shots (needed to prevent equip/dequip exploit)
};

datablock ShapeBaseImageData(BQueenSpitHealimage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 5;
   offset = "0 0 -1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.04;
	stateTransitionOnTimeout[0]      = "Heal1";
	stateScript[0]                  = "onActivate";

	stateName[1]                     = "Heal1";
	stateTransitionOnTimeout[1]      = "Done";
	stateTimeoutValue[1]             = 0.02;
	stateScript[1]                  = "onHeal";
	stateAllowImageChange[1]         = false;
//	stateEmitter[1]			= BQueenHealEmoteEmitter;
//	stateEmitterTime[1]		= 0.02;
//	stateEmitterNode[1]		= "muzzleNode";

	stateName[2]			= "Done";
	stateTransitionOnTimeout[2]      = "Activate";
	stateTimeoutValue[2]             = 0.02;
};

function BQueenSpitHealImage::onMount(%this,%obj,%slot)
{
	%this.healing = 0;
	Parent::onMount(%this,%obj,%slot);	
}

//function canFireSyringeGun(%obj)
//{
//		centerprint(%obj.client,"<color:fff000>Hypojet reloaded!<br><color:ffffff>You can use it again." ,5);
//            		serverPlay3D(BQueenSpitReloadSound,%obj.getPosition());
//}

function BQueenSpitHealImage::onHeal(%this,%obj,%slot)
{
	if(%obj.getDamageLevel() >= 1)
	{
		if(%this.healing <= 10)
		{
		%obj.setDamageLevel(%obj.getDamageLevel()-1);
		%this.healing++;
		}
	}
	else
	{
		%obj.setDamageLevel(0);
		%this.healing++;
	}
		if(%this.healing >= 10)
		{
		%obj.unMountImage(%slot);
		}
}

function BQueenSpitImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastMediTime+%this.minShotTime) > getSimTime() && %this.usedBQueenSpit == 1)
	{
		return;
	}
	%obj.playThread(2, plant);
//            	serverPlay3D(BQueenSpitShot1Sound,%obj.getPosition());

	Parent::onFire(%this,%obj,%slot);	
}

function BQueenSpitProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	%damage = %this.directDamage;
//	%player = %obj.client.player;

	%scale = getWord(%obj.getScale(), 2);
	
	if(%col.getClassName() $= "Player")
	{
		if(isObject(%col.client.minigame))
		{
			if(%obj.client.minigame $= %col.client.minigame)
			{
				if(%col.client.getTeam().name $= %obj.client.getTeam().name)
				{
					if(!%col.isMechanical && !%col.getDatablock().isMechanical)
					{
						if(%col.getDamageLevel() != 0)
						{
							if(%col.getDamageLevel() >= %damage)
							{
								%col.spawnExplosion(BQueenHealProjectile,"1 1 1");
								%col.setDamageLevel(%col.getDamageLevel()-%damage);
								bottomPrint(%obj.client,"\c6<font:impact:32>" @ %col.client.name @ "<font:impact:18> was healed by you.",1,3);
								bottomPrint(%col.client,"\c6<font:impact:32>" @ %obj.client.name @ "<font:impact:18> is healing you.",1,3);
							}
							else
							{
								%col.setDamageLevel(0);
							}
						}
						//%col.emote(BQueenSpithealImage);
					}
				} 
				else 
				{
					Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);	//If not on same team, deal damage
				}
			}
		}
	}
	else 
	{
		if(%col.isHoleBot || %col.getDatablock().isHoleBot)
		{
			//if(%col.getDatablock().hType $= Friendly) 
			if(%col.hType $= Friendly) 
			{
				if(!%col.isMechanical && !%col.getDatablock().isMechanical)
				{
					if(%col.getDamageLevel() != 0)
					{
						if(%col.getDamageLevel() >= %damage)
						{
							%col.spawnExplosion(BQueenHealProjectile,"1 1 1");
							%col.setDamageLevel(%col.getDamageLevel()-%damage);
						}
						else
						{
							%col.setDamageLevel(0);
						}
					}
				} 
			}
			else
			{
				Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
			}
		}
	}

}


