//Weapon_Bug_AcidExplosion.cs


//Explosion Smoke
datablock ParticleData(BugAcidExplosionParticle)
{
	dragCoefficient      = 3;	//8
	gravityCoefficient   = 0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -40;		//-90
	spinRandomMax 		= 40;		//90
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 800;
	textureName          = "base/data/particles/cloud";
	colors[0]     = "0.530 0.825 0.278 0.4";
	colors[1]     = "0.697 0.770 0.380 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 4.5;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(BugAcidExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;
   ejectionVelocity = 7;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BugAcidExplosionParticle";

   uiName = "Bug Explosion";
};

//Explosion Flash
datablock ParticleData(BugAcidExplosionFlashParticle)
{
	dragCoefficient      = 0;	//8
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.5;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	colors[0]     = "0.6 1.0 0.0 0.9";
	colors[1]     = "0.3 1.0 0.1 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 4.5;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(BugAcidExplosionFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BugAcidExplosionFlashParticle";

   uiName = "Bug Explosion Flash";
};

datablock ExplosionData(BugAcidExplosion)
{
//	explosionShape = "base/data/shapes/empty.dts";
	explosionShape = "add-ons/Weapon_Rocket_Launcher/explosionsphere1.dts";
   lifeTimeMS = 300;	//500

   soundProfile = rocketExplodeSound;

   particleEmitter = BugAcidExplosionEmitter;
   particleDensity = 25;	//35
   particleRadius = 0.1;

	emitter[0] = BugAcidExplosionFlashEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

	damageRadius = 8;	//3
	radiusDamage = 70;	//60

	impulseRadius = 7;
	impulseForce = 1500;

   shakeCamera = true;
   camShakeFreq = "1.0 2.0 1.0";
   camShakeAmp = "10.0 20.0 5.0";
   camShakeDuration = 0.2;
   camShakeRadius = 2.8;

//Poison stuff
	poison = 1;					//(No default)Has to be 1, for the code to recognize this is a poison projectile/explosion
	poisonSound = "BugAcidPulseSound";
	poisonImage = "BugAcidStatusPlayerImage";	//(Default: EmptyPoisonPlayerImage)Visual effect of the poison
	poisonChance = 100;		//(Default: 100) Chance to poison victim (100 for always)
	poisonType = "BugAcid";			//(Default: "Standard") Example: "SpiderPoison", used for immunity checks and curing of specific poisons
	poisonDamage = 8;		//(Default: 1) Do you need an example here? >_>
	poisonMinHealth = 0;	//(Default: 0) Poison stops when it reaches this amount of health. (0 to kill :D)
	poisonPulseDelay = 600;	//(Default: 500, Minimum: 500) Delay (in ms) between pulses (somewhere around 1000 is the best lowest when looking at the interval between heart beats)
	poisonMaxPulses = 8;	//(Default: 10) Maximum amount of pulses
	poisonShake = 2;			//(Default: 0) 0 = No screen shake effect ; 1 = High screen shake effect ; 2 = Medium screen shake effect ; 3 = Low screen shake effect
	poisonFlash = 0;		//(Default: 0) 0 = no flash at all ; 1 = whiteOut every pulse ; 2 = damageFlash (redOut) every pulse
//	poisonFlashAmount = 0;	//(Default: 50) Only used when flash isn't 0, determines intensity of flash
	poisonDrain = 0;		//(Default: 0) 2 = drains (with amount of poisonDamage) health until it's at health determined by poisonMinHealth ; 1 = Acts like a normal poison, but does not stop when the player is on poisonMinHealth.
	poisonSpread = 1;		//(Default: 0) 1 = When a victim touches the poisonInfected person, he/she/it mite get infected too!
	poisonOverwrite = 1;		//(Default: 1) 2 = Overwrites poison victim already has (if same type) ; 1 = Overwrites poison victim already has ; 0 = Resets poison of victim
	poisonDamageAmp = 1.3;

};

//projectile
//AddDamageType("BugAcidExplosion",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(BugAcidExplosionProjectile)
{
	directDamage		= 1;
	directDamageType	= $DamageType::BugAcidExplosion;
	radiusDamageType	= $DamageType::BugAcidExplosion;
	explosion			= BugAcidExplosion;
	explodeOnDeath		= true;
	particleEmitter		= "";

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

   muzzleVelocity      = 1;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 1;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Bug Explosion";
};


//////////
// item //
//////////
datablock ItemData(BugAcidExplosionItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Bug Self-Detonate";
	iconName = "./icon_bugBoom";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = BugAcidExplosionImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BugAcidExplosionImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = BugAcidExplosionProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

	energyUsage = 95;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

//	stateName[2]			= "PreFire";
//	stateScript[2]                  = "onPreFire";
//	stateAllowImageChange[2]        = false;
//	stateTimeoutValue[2]            = 0.1;
//	stateTransitionOnTimeout[2]     = "Fire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Ready";
	stateTimeoutValue[2]            = 0.7;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
//	stateName[3]                    = "Recharge";
//	stateTransitionOnTimeout[3]     = "Ready";
//	stateTimeoutValue[3]            = 0.4;
//	stateAllowImageChange[3]        = false;
//	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
//	stateScript[3]                  = "onStopFire";


};

function BugAcidExplosionImage::onFire(%this, %obj, %slot)
{
	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
//		%obj.playthread(2, activate);
//	    if(%obj.getDamagePercent() < 1.0)
//			%obj.playthread(2, activate);
		Parent::onFire(%this,%obj,%slot);
//		kill(%obj);
	}
	else
	{
		centerprint(%obj.client,"<color:ffffff>You need full energy to self-detonate!" ,2);
	}
}

//function swordImage::onStopFire(%this, %obj, %slot)
//{	
//	%obj.playthread(2, root);
//}

