//Weapon_Bug_AcidSpit.cs

//audio
datablock AudioProfile(BugAcidPulseSound)
{
   filename    = "./acid_burn.wav";	//Sound obtained from freesound.org, and was recorded by user "aristotleathiras"
   description = AudioClose3d;
   preload = true;
};

//hit effects
datablock ParticleData(BugAcidSpitHitParticle)
{
	dragCoefficient      = 4;	//4
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 800;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.530 0.825 0.591 0.7";
	colors[1]     = "0.697 0.770 0.380 0.0";
	sizes[0]      = 0.20;
	sizes[1]      = 0.18;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(BugAcidSpitHitEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 1;
   ejectionVelocity = 8;	//6
   velocityVariance = 3.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BugAcidSpitHitParticle";

   uiName = "Bug Acid Hit";
};


//trail effects
datablock ParticleData(BugAcidSpitTrailParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.05;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	spinRandomMin 	     = 0;
	spinRandomMax 		= 0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.6 0.790 0.6 0.1";
	colors[1]     = "0.435 0.676 0.472 0.2";
	colors[2]     = "0.697 0.770 0.300 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;
	sizes[2]      = 0.0;
	times[0]	  = 0.0;
	times[1]	  = 0.2;
	times[2]	  = 1.0;

	useInvAlpha		= false;

};

datablock ParticleEmitterData(BugAcidSpitTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 180;
   overrideAdvance = false;
   particles = "BugAcidSpitTrailParticle";

   uiName = "Bug Acid Trail";
};

////////////////////////
// Poison Image stuff //
////////////////////////
datablock ParticleData(BugAcidStatusParticle)
{
	dragCoefficient      = 0.2;
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 1300;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.6 0.7 0.3 0.3";
	colors[1]     = "0.75 0.8 0.4 0.4";
	colors[2]     = "0.3 0.79 0.2 0.0";
//	colors[3]     = "0.4 0.6 0.4 0.0";
	sizes[0]      = 0.01;
	sizes[1]      = 0.25;
	sizes[2]      = 0.05;
//	sizes[3]      = 0.0;
	times[0]	  = 0.0;
	times[1]	  = 0.3;
	times[2]	  = 1;
//	times[3]	  = 1.0;

};

datablock ParticleEmitterData(BugAcidStatusEmitter)
{
   ejectionPeriodMS = 30;	//7
   periodVarianceMS = 2;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BugAcidStatusParticle";

   uiName = "Bug Acid Bubbles";
};

datablock ParticleData(BugAcidPulseParticle)
{
	dragCoefficient      = 0.8;
	gravityCoefficient   = -1.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	colors[0]     = "0.8 0.9 0.6 0.2";
	colors[1]     = "0.7 0.7 0.7 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 0.01;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(BugAcidPulseEmitter)
{
   ejectionPeriodMS = 70;	//7
   periodVarianceMS = 5;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.6;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BugAcidPulseParticle";

   uiName = "Bug Acid Pulse";
};

datablock ShapeBaseImageData(BugAcidStatusPlayerImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 5;
   offset = "0 0 -0.3";
   eyeOffset = 0;
   rotation = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = "";
   ammo = " ";
   projectile = "";
   projectileType = Projectile;
   
   isPoison = 1;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = "1 1 1 1";

	//lightType = "ConstantLight";
	//lightColor = "0 1 0";
	//lightRadius = 4;

	stateName[0]                   = "Wait";
	stateTimeoutValue[0]           = 0.5;
	stateEmitter[0]                = BugAcidStatusEmitter;
	stateEmitterTime[0]            = 1;
	stateTransitionOnTimeout[0]    = "Poison";
	//stateSound[0]                  = FireLoopSound;	//No sound

	stateName[1]                   = "Poison";
	//stateScript[1]                 = "Damage";
	stateEmitter[1]                = BugAcidPulseEmitter;
	stateEmitterTime[1]            = 0.2;
	stateTimeoutValue[1]           = 0.1;
	stateTransitionOnTimeout[1]    = "Wait";
	//stateSound[1]                  = FireShotSound;	//No sound
};

//Explosion
datablock ExplosionData(BugAcidSpitExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = BugAcidSpitHitEmitter;
   particleDensity = 25;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

	damageRadius = 2;	//1.5
	radiusDamage = 5;

	impulseRadius = 0.01;
	impulseForce = 1000;

   shakeCamera = true;
   camShakeFreq = "6.0 6.0 5.0";
   camShakeAmp = "10.0 15.0 5.0";
   camShakeDuration = 0.4;
   camShakeRadius = 2.0;

//Poison stuff
	poison = 1;					//(No default)Has to be 1, for the code to recognize this is a poison projectile/explosion
	poisonSound = "BugAcidPulseSound";
	poisonImage = "BugAcidStatusPlayerImage";	//(Default: EmptyPoisonPlayerImage)Visual effect of the poison
	poisonChance = 100;		//(Default: 100) Chance to poison victim (100 for always)
	poisonType = "BugAcid";			//(Default: "Standard") Example: "SpiderPoison", used for immunity checks and curing of specific poisons
	poisonDamage = 5;	//10	//(Default: 1) Do you need an example here? >_>
	poisonMinHealth = 0;	//(Default: 0) Poison stops when it reaches this amount of health. (0 to kill :D)
	poisonPulseDelay = 600;	//900	//(Default: 500, Minimum: 500) Delay (in ms) between pulses (somewhere around 1000 is the best lowest when looking at the interval between heart beats)
	poisonMaxPulses = 5;	//3	//(Default: 10) Maximum amount of pulses
	poisonShake = 0;			//(Default: 0) 0 = No screen shake effect ; 1 = High screen shake effect ; 2 = Medium screen shake effect ; 3 = Low screen shake effect
	poisonFlash = 0;		//(Default: 0) 0 = no flash at all ; 1 = whiteOut every pulse ; 2 = damageFlash (redOut) every pulse
//	poisonFlashAmount = 0;	//(Default: 50) Only used when flash isn't 0, determines intensity of flash
	poisonDrain = 0;		//(Default: 0) 2 = drains (with amount of poisonDamage) health until it's at health determined by poisonMinHealth ; 1 = Acts like a normal poison, but does not stop when the player is on poisonMinHealth.
	poisonSpread = 0;		//(Default: 0) 1 = When a victim touches the poisonInfected person, he/she/it mite get infected too!
	poisonOverwrite = 2;		//(Default: 1) 2 = Overwrites poison victim already has (if they are of the same type) ; 1 = Overwrites poison victim already has ; 0 = Resets poison of victim

};

//projectile
AddDamageType("BugAcidSpit",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(BugAcidSpitProjectile)
{
   directDamage        = 8;
   directDamageType  = $DamageType::BugAcidSpit;
   radiusDamageType  = $DamageType::BugAcidSpit;
   explosion           = BugAcidSpitExplosion;
	particleEmitter = BugAcidSpitTrailEmitter;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

   muzzleVelocity      = 55;
   velInheritFactor    = 0.5;

   armingDelay         = 0;
   lifetime            = 1200;
   fadeDelay           = 800;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.5;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Bug Acid";
};


//////////
// item //
//////////
datablock ItemData(BugAcidSpitItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Bug Acid Spit";
	iconName = "./icon_acidSpit";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = BugAcidSpitImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BugAcidSpitImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = BugAcidSpitProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

	energyUsage = 20;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

//	stateName[2]			= "PreFire";
//	stateScript[2]                  = "onPreFire";
//	stateAllowImageChange[2]        = false;
//	stateTimeoutValue[2]            = 0.1;
//	stateTransitionOnTimeout[2]     = "Fire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Ready";
	stateTimeoutValue[2]            = 0.7;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
//	stateName[3]                    = "Recharge";
//	stateTransitionOnTimeout[3]     = "Ready";
//	stateTimeoutValue[3]            = 0.4;
//	stateAllowImageChange[3]        = false;
//	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
//	stateScript[3]                  = "onStopFire";


};

function BugAcidSpitImage::onFire(%this, %obj, %slot)
{
	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		%obj.playthread(2, plant);
//	    if(%obj.getDamagePercent() < 1.0)
//			%obj.playthread(2, activate);
		Parent::onFire(%this,%obj,%slot);
	} else {
		centerprint(%obj.client,"<color:ffffff>You need more energy to spit your acid!" ,2);	
	}
}

//function swordImage::onStopFire(%this, %obj, %slot)
//{	
//	%obj.playthread(2, root);
//}

