//Weapon_Mt_Poison.cs


//effects
datablock ParticleData(PoisonMiteBiteHitParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 2.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	colors[0]     = "1.0 0.3 0.0 0.7";
	colors[1]     = "1.0 0.6 0.0 0.1";
	sizes[0]      = 0.2;
	sizes[1]      = 0.02;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(PoisonMiteBiteHitEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 1;
   ejectionVelocity = 3;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PoisonMiteBiteHitParticle";

   uiName = "Mite Poison";
};

////////////////////////
// Poison Image stuff //
////////////////////////
datablock ParticleData(PoisonMiteStatusParticle)
{
	dragCoefficient      = 0.1;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	colors[0]     = "1.0 0.6 0.0 0.01";
	colors[1]     = "1.0 0.3 0.0 0.1";
	colors[2]     = "1.0 0.6 0.0 0.01";
	sizes[0]      = 1.7;
	sizes[1]      = 2.5;
	sizes[2]      = 1;
	times[0]	  = 0.0;
	times[1]	  = 0.3;
	times[2]	  = 1.0;

};

datablock ParticleEmitterData(PoisonMiteStatusEmitter)
{
   ejectionPeriodMS = 100;	//7
   periodVarianceMS = 2;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PoisonMiteStatusParticle";

   uiName = "Mite Poison Cloud";
};

datablock ShapeBaseImageData(PoisonMiteStatusPlayerImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 5;
   offset = "0 0 -0.5";
   eyeOffset = 0;
   rotation = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = "";
   ammo = " ";
   projectile = "";
   projectileType = Projectile;
   
   isPoison = 1;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = "1 1 1 1";

	//lightType = "ConstantLight";
	//lightColor = "0 1 0";
	//lightRadius = 4;

	stateName[0]                   = "Wait";
	stateTimeoutValue[0]           = 0.4;
	stateEmitter[0]                = PoisonMiteStatusEmitter;
	stateEmitterTime[0]            = 0.5;
	stateTransitionOnTimeout[0]    = "Poison";
	//stateSound[0]                  = FireLoopSound;	//No sound

	stateName[1]                   = "Poison";
	//stateScript[1]                 = "Damage";
	stateEmitter[1]                = PoisonMiteBiteHitEmitter;
	stateEmitterTime[1]            = 0.2;
	stateTimeoutValue[1]           = 0.1;
	stateTransitionOnTimeout[1]    = "Wait";
	//stateSound[1]                  = FireShotSound;	//No sound
};

datablock ExplosionData(PoisonMiteBiteExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = PoisonMiteBiteHitEmitter;
   particleDensity = 15;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1.0 1.0 1.0";
   camShakeAmp = "20.0 25.0 10.0";
   camShakeDuration = 0.1;
   camShakeRadius = 8.0;
};


//projectile
//AddDamageType("Spiderbite",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(PoisonMiteBiteProjectile)
{
   directDamage        = 7;	//10
   directDamageType  = $DamageType::Mitebite;
   radiusDamageType  = $DamageType::Mitebite;
   explosion           = PoisonMiteBiteExplosion;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Mite Poison";

	//Poison stuff
	poison = 1;					//(No default)Has to be 1, for the code to recognize this is a poison projectile/explosion
	poisonSound = 1;
	poisonImage = "PoisonMiteStatusPlayerImage";	//(Default: EmptyPoisonPlayerImage)Visual effect of the poison
	poisonChance = 100;		//(Default: 100) Chance to poison victim (100 for always)
	poisonType = "MitePoison";			//(Default: "Standard") Example: "SpiderPoison", used for immunity checks and curing of specific poisons
	poisonDamage = 4;		//(Default: 1) Do you need an example here? >_>
	poisonMinHealth = 5;	//(Default: 0) Poison stops when it reaches this amount of health. (0 to kill :D)
	poisonPulseDelay = 1000;	//(Default: 500, Minimum: 500) Delay (in ms) between pulses (somewhere around 1000 is the best lowest when looking at the interval between heart beats)
	poisonMaxPulses = 5;	//(Default: 10) Maximum amount of pulses
	poisonShake = 2;			//(Default: 0) 0 = No screen shake effect ; 1 = High screen shake effect ; 2 = Medium screen shake effect ; 3 = Low screen shake effect
	poisonDrain = 0;		//(Default: 0) 1 = Acts like a normal poison, but does not stop when the victim is on poisonMinHealth ; 2 = Same as 1 but sets the victim to poisonMinHealth right off the start.
	poisonDamageAmp = 1.5;	// (Default: 0) Multiplier of any non-poison damage the target will receive when having this poison.
	poisonSpread = 0;		//(Default: 0) 1 = When a victim touches the poisonInfected person, he/she/it mite get infected too!
	poisonOverwrite = 2;		//(Default: 1) 2 = Overwrites poison victim already has (if they are of the same type) ; 1 = Overwrites poison victim already has ; 0 = Resets poison of victim

};


//////////
// item //
//////////
datablock ItemData(PoisonMiteBiteItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Mite Poison";
	iconName = "./icon_poisonMiteBite";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = PoisonMiteBiteImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PoisonMiteBiteImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = PoisonMiteBiteProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

//	stateName[2]			= "PreFire";
//	stateScript[2]                  = "onPreFire";
//	stateAllowImageChange[2]        = false;
//	stateTimeoutValue[2]            = 0.1;
//	stateTransitionOnTimeout[2]     = "Fire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recharge";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[3]                    = "Recharge";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 0.25;
	stateAllowImageChange[3]        = false;
	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
//	stateScript[3]                  = "onStopFire";


};

function PoisonMiteBiteImage::onFire(%this, %obj, %slot)
{
	    if(%obj.getDamagePercent() < 1.0)
			%obj.playthread(2, activate);
		Parent::onFire(%this,%obj,%slot);
}

//function swordImage::onStopFire(%this, %obj, %slot)
//{	
//	%obj.playthread(2, root);
//}
