//Weapon_Wsp_Sting.cs

datablock ExplosionData(WaspStingExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 250;

   soundProfile = swordHitSound;

   particleEmitter = WaspStingSprayEmitter;
   particleDensity = 15;
   particleRadius = 0.2;
   
   emitter[0] = WaspStingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 3.0 1.0";
   camShakeAmp = "18.0 20.0 8.0";
   camShakeDuration = 0.2;
   camShakeRadius = 5.0;

	impulseRadius = 2;
	impulseForce = 800;	//1800

	damageRadius = 0.01;
	radiusDamage = 0.01;
};


//projectile
//AddDamageType("Waspsting",   '<bitmap:add-ons/Bot_BugMod4_HiveInvasion/CI_wasp_sting> %1',    '%2 <bitmap:add-//ons/Bot_BugMod4_HiveInvasion/CI_wasp_sting> %1',0.75,1);
datablock ProjectileData(WaspStingProjectile)
{
   directDamage        = 20;
   directDamageType  = $DamageType::Waspsting;
   radiusDamageType  = $DamageType::Waspsting;
   explosion           = WaspStingExplosion;

	impactImpulse	   = 0;
	verticalImpulse	   = 500;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 85;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Wasp Sting";

	//Poison stuff
	poison = 1;							//(No default)Has to be 1, for the code to recognize this is a poison projectile/explosion
    poisonSound = 1;
	poisonImage = PoisonStatusPlayerImage;			//(Default: EmptyPoisonPlayerImage)Visual effect of the poison
	poisonChance = 100;					//(Default: 100) Chance to poison victim (100 for always)
	poisonType = "WaspPoison";		//Example: "SpiderPoison", used for immunity checks and curing of specific poisons
	poisonDamage = 15;		//20
//	poisonMinHealth = number;			//(Default: 0) Poison stops when it reaches this amount of health. (0 to kill :D)
	poisonPulseDelay = 1400;	//1000			//Delay (in ms) between pulses (somewhere around 1000 is the best lowest when looking at the interval between heart beats)
	poisonMaxPulses = 3;				//(Default: 10) Maximum amount of pulses
	poisonOverwrite = 1;				//(Default: 1) 2 = Overwrites poison victim already has (if they are of the same type) ; 1 = Overwrites poison victim already has ; 0 = Resets poison of victim

};


//////////
// item //
//////////
datablock ItemData(WaspStingItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Wasp Sting";
//	iconName = "./icon_SpiderBite";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = WaspStingImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(WaspStingImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = WaspStingProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Recharge";
	stateTimeoutValue[3]            = 0.01;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
//	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[4]                    = "Recharge";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 0.35;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]			= true;
//	stateSequence[4]                = "StopFire";
	stateScript[4]                  = "onStopFire";
};

function WaspStingImage::onFire(%this, %obj, %slot)
{
//	%obj.playthread(0, activate);
//	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, sting);
//		%obj.playThread(3, stingLegs);
//		%obj.playThread(2, stingTail);
	Parent::onFire(%this,%obj,%slot);
}

function WaspStingImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, stingReady);
}

function WaspStingImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
	%obj.playThread(1, root);
}

//function WaspStingImage::onStopFire(%this, %obj, %slot)
//{
//		%obj.playThread(2, armReadyRight);
//}
